# Enum Class ClassFile.ShortJumpsOption

java.lang.Object
java.lang.Enum<ClassFile.ShortJumpsOption>
java.lang.classfile.ClassFile.ShortJumpsOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.ShortJumpsOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.ShortJumpsOption extends Enum<ClassFile.ShortJumpsOption> implements ClassFile.Option
The option describing whether to automatically rewrite short jumps to equivalent instructions when necessary. The default is `FIX_SHORT_JUMPS` to automatically rewrite.

Due to physical restrictions, some types of instructions cannot encode certain jump targets with bci offsets less than -32768 or greater than 32767, as they use a `s2` to encode such an offset. (The maximum length of the `code` array is 65535.) These types of instructions are called "short jumps".

Disabling rewrite can ensure the physical accuracy of a generated `class` file and avoid the overhead from a failed first attempt for overflowing forward jumps in some cases, if the generated `class` file is stable.

Since:
  24
See Also:
  - `BranchInstruction`
  - `DiscontinuedInstruction.JsrInstruction`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `FAIL_ON_SHORT_JUMPS`
  Fail with an `IllegalArgumentException` if short jump overflows.
  `FIX_SHORT_JUMPS`
  Automatically convert short jumps to long when necessary.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.ShortJumpsOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.ShortJumpsOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(ClassFile.ShortJumpsOption o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<ClassFile.ShortJumpsOption>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<ClassFile.ShortJumpsOption>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### FIX_SHORT_JUMPS

    public static final ClassFile.ShortJumpsOption FIX_SHORT_JUMPS
    Automatically convert short jumps to long when necessary.

    For an invalid instruction model, a `CodeBuilder` may generate another or a few other instructions to accomplish the same effect.

  - ### FAIL_ON_SHORT_JUMPS

    public static final ClassFile.ShortJumpsOption FAIL_ON_SHORT_JUMPS
    Fail with an `IllegalArgumentException` if short jump overflows.

    This is useful to ensure the physical accuracy of a generated `class` file and avoids the overhead from a failed first attempt for overflowing forward jumps in some cases.

- ## Method Details

  - ### values

    public static ClassFile.ShortJumpsOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.ShortJumpsOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null